function int oneshot_cvarinfo(void)
{
    return GetCVar("oneshot_usescvarinfo") == 420420420;
}

function int oneshot_dcvar(int name, int val)
{
    if (oneshot_cvarinfo()) { return GetCVar(name); }
    return defaultCVar(name, val);
}

function int oneshot_save(int name, int val)
{
    if (oneshot_cvarinfo()) { SetCVar(name, val); }  // ZDum
    else { saveCVar(name, val); }  // Z&

    return GetCVar(name);
}

function int oneshot_hudX(int width)
{
    int baseX = oneshot_dcvar("oneshot_hudx", 800);
    baseX = middle(0, baseX, 1000) * (width * 0.001);
    baseX = (baseX >> 16) << 16;
    return baseX;
}

function int oneshot_hudY(int height)
{
    int baseY = oneshot_dcvar("oneshot_hudy", 200);
    baseY = middle(0, baseY, 1000) * (height * 0.001);
    baseY = (baseY >> 16) << 16;
    return baseY;
}

function int cvarWeakness(void)
{
    int weakness = oneshot_dcvar("oneshot_weakness", WEAKNESS_COUNT);
    
    if (middle(1, weakness, WEAKNESS_COUNT) != weakness)
    {
        weakness = oneshot_save("oneshot_weakness", middle(1, weakness, WEAKNESS_COUNT));
    }

    return weakness - 1;
}

function int cvarMWeakness(void)
{
    int weakness = oneshot_dcvar("oneshot_strength", MWEAKNESS_COUNT);
    
    if (middle(1, weakness, MWEAKNESS_COUNT) != weakness)
    {
        weakness = oneshot_save("oneshot_strength", middle(1, weakness, MWEAKNESS_COUNT));
    }

    return weakness - 1;
}

function int cvarGambler(void)
{
    int gambler = oneshot_dcvar("oneshot_gambler", 0);
    
    if (!!gambler != gambler)
    {
        gambler = oneshot_save("oneshot_gambler", !!gambler);
    }

    return !!gambler;
}

function int cvarGamblerDie(void)
{
    int gambler = oneshot_dcvar("oneshot_gamblerdie", 10);
    
    if (gambler < 1)
    {
        gambler = oneshot_save("oneshot_gamblerdie", 1);
    }

    return gambler;
}

function int cvarNoRandom(void)
{
    int norandom = oneshot_dcvar("oneshot_norandom", 0);

    if (!!norandom != norandom)
    {
        norandom = oneshot_save("oneshot_norandom", !!norandom);
    }

    return norandom;
}

function int weaknessNum(int weakness)
{
    if (weakness < 0 || weakness >= WEAKNESS_COUNT) { return 1; }
    return weaknessNums[weakness];
}

function int mWeaknessNum(int mWeakness)
{
    if (mWeakness < 0 || mWeakness >= MWEAKNESS_COUNT) { return 1; }
    return monWeaknessNums[mWeakness];
}

function int weaknessName(int weakness)
{
    if (weakness < 0 || weakness >= WEAKNESS_COUNT) { return ""; }
    return weaknessNames[weakness];
}

function int mWeaknessName(int mWeakness)
{
    if (mWeakness < 0 || mWeakness >= MWEAKNESS_COUNT) { return ""; }
    return monWeaknessNames[mWeakness];
}

function int skillName(int weakness, int mWeakness)
{
    if (weakness < 0 || weakness >= WEAKNESS_COUNT) { return ""; }
    if (mWeakness < 0 || mWeakness >= MWEAKNESS_COUNT) { return ""; }

    if (StrLen(skillNames[weakness][mWeakness]))
    {
        return skillNames[weakness][mWeakness];
    }

    return StrParam(s:"\cd", s:monWeaknessNames[mWeakness], s:"\cj + \ca", s:weaknessNames[weakness], s:"\c-");
}

function void setWeakness(int weakness)
{
    int i, g, w;

    if (weakness < 0 || weakness >= WEAKNESS_COUNT) { return; }

    for (i = 0; i < WEAKNESS_COUNT; i++)
    {
        g = (i == weakness);
        w = weaknesses[i];
        if (g && !CheckInventory(w)) { GiveInventory(w, 1); }
        else if (!g && CheckInventory(w)) { TakeInventory(w, 0x7FFFFFFF); }
    }
}

function void setMWeakness(int weakness)
{
    int i, g, w;

    if (weakness < 0 || weakness >= MWEAKNESS_COUNT) { return; }

    for (i = 0; i < MWEAKNESS_COUNT; i++)
    {
        g = (i == weakness);
        w = monWeaknesses[i];
        if (g && !CheckInventory(w)) { GiveInventory(w, 1); }
        else if (!g && CheckInventory(w)) { TakeInventory(w, 0x7FFFFFFF); }
    }
}

function void setStrength(int tostrength)
{
    int i, g, strength, safety;

    if (tostrength < 0 || tostrength >= MWEAKNESS_COUNT) { return; }

    for (i = 0; i < MWEAKNESS_COUNT; i++)
    {
        g = (i == tostrength);
        strength = strengths[i];
        safety   = safeties[i];

        if (g)
        {
            if (!CheckInventory(strength)) { GiveInventory(strength, 1); }
            if (!CheckInventory(safety))   { GiveInventory(safety, 1); }
        }
        else
        {
            if (CheckInventory(strength)) { TakeInventory(strength, 0x7FFFFFFF); }
            if (CheckInventory(safety))   { TakeInventory(safety, 0x7FFFFFFF); }
        }
    }
}

function void ShowNewSkill(int weakness, int mweakness)
{
    if (GameType() == GAME_SINGLE_PLAYER) { return; }

    SetHudSize(480, 360, 1);

    int name = skillName(weakness, mweakness);
    int base = (ONESHOT_BASE + 2) * 100;

    int weakNum = weaknessNum(weakness);
    int mwekNum = mWeaknessNum(mweakness);

    HudMessageBold(s:"Oneshot skill switched to \cf", s:name; HUDMSG_FADEOUT, base, CR_WHITE, 240.4, 45.0, 2.0, 2.0);
    HudMessageBold(d:mwekNum, s:"x\cq done"; HUDMSG_FADEOUT, base+1, CR_GREEN, 220.2, 55.0, 2.0, 2.0);
    HudMessageBold(d:weakNum, s:"x\cr taken"; HUDMSG_FADEOUT, base+2, CR_BRICK, 260.1, 55.0, 2.0, 2.0);

}

function void FlashWeakness(int weakness)
{
    SetHudSize(640, 480, 1);

    if (oneshot_dcvar("oneshot_hidehud", 0)) { return; }

    int base = (ONESHOT_BASE - 1) * 100;
    int weakNum = weaknessNum(weakness);
    int baseX = oneshot_hudX(640);
    int baseY = oneshot_hudY(480);

    HudMessage(d:weakNum, s:"x"; HUDMSG_FADEOUT, base+3, CR_DARKRED,     baseX - 2.8,    baseY + 24.1,   0.5, 1.5);
    HudMessage(s:"damage taken"; HUDMSG_FADEOUT, base+5, CR_BRICK,       baseX + 2.1,    baseY + 24.1,   0.5, 1.5);
}

function void FlashMWeakness(int weakness)
{
    SetHudSize(640, 480, 1);

    if (oneshot_dcvar("oneshot_hidehud", 0)) { return; }
    int base = (ONESHOT_BASE - 1) * 100;
    int weakNum = mWeaknessNum(weakness);
    int baseX = oneshot_hudX(640);
    int baseY = oneshot_hudY(480);

    HudMessage(d:weakNum, s:"x"; HUDMSG_FADEOUT, base+2, CR_DARKGREEN,   baseX - 2.8,    baseY + 12.1,   0.5, 1.5);
    HudMessage(s:"damage done"; HUDMSG_FADEOUT,  base+4, CR_GREEN,       baseX + 2.1,    baseY + 12.1,   0.5, 1.5);
}

function void FlashGambler(int gambler, int sides)
{
    SetHudSize(640, 480, 1);

    if (oneshot_dcvar("oneshot_hidehud", 0)) { return; }

    int base = (ONESHOT_BASE - 1) * 100;
    int baseX = oneshot_hudX(640);
    int baseY = oneshot_hudY(480);
    int gambleColor = cond(gambler, CR_GOLD, CR_WHITE);
    int gambleMsg   = cond(gambler, StrParam(s:"\cu1d\cn", d:sides), "\cnNo");

    HudMessage(s:gambleMsg;     HUDMSG_FADEOUT, base+6, CR_DARKGREY,    baseX - 2.8,    baseY + 36.1,   0.5, 1.5);
    HudMessage(s:"gambler die"; HUDMSG_FADEOUT, base+7, gambleColor,    baseX + 2.1,    baseY + 36.1,   0.5, 1.5);
}

function void FlashNoRandom(int norandom)
{
    SetHudSize(640, 480, 1);

    if (oneshot_dcvar("oneshot_hidehud", 0)) { return; }

    int base = (ONESHOT_BASE - 1) * 100;
    int baseX = oneshot_hudX(640);
    int baseY = oneshot_hudY(480);
    int randomMsg = cond(norandom, "No", "With");

    HudMessage(s:randomMsg;       HUDMSG_FADEOUT, base+8, CR_DARKBROWN, baseX - 2.8,    baseY + 48.1,   0.5, 1.5);
    HudMessage(s:"random damage"; HUDMSG_FADEOUT, base+9, CR_TAN,       baseX + 2.1,    baseY + 48.1,   0.5, 1.5);
}

function void DrawOneshotHud_Base(int name, int weakness, int mweakness, int gambler, int norandom)
{
    SetHudSize(640, 480, 1);
    if (oneshot_dcvar("oneshot_hidehud", 0)) { return; }

    int i;
    
    int namelen = max(4, StrLen(cleanString(name)) - 1);
    int base = ONESHOT_BASE * 100;

    int bgnStr = "\x1d", midStr = "\x1e", endStr = "\x1f";
    if (!oneshot_cvarinfo()) { bgnStr = "\x1d "; midStr = "\x1e "; endStr = "\x1f "; }

    int bar = bgnStr;

    for (i = 0; i < namelen; i++)
    {
        bar = StrParam(s:bar, s:midStr);
    }

    bar = StrParam(s:bar, s:endStr);

    int baseX = oneshot_hudX(640);
    int baseY = oneshot_hudY(480);

    HudMessage(s:name;                  HUDMSG_FADEOUT, base,   CR_GOLD,        baseX + 30.4,   baseY + 0.2,    1.0, 0.5);

    SetFont("CONFONT");
    HudMessage(s:bar;                   HUDMSG_FADEOUT, base+1, CR_OLIVE,       baseX + 30.4,   baseY + 5.0,    1.0, 0.5);
    SetFont("SMALLFONT");

    HudMessage(s:weakness, s:"\c-x";    HUDMSG_FADEOUT, base+2, CR_GREEN,       baseX - 2.8,    baseY + 12.1,   1.0, 0.5);
    HudMessage(s:"damage done";         HUDMSG_FADEOUT, base+3, CR_DARKGREEN,   baseX + 2.1,    baseY + 12.1,   1.0, 0.5);
    HudMessage(s:mweakness, s:"\c-x";   HUDMSG_FADEOUT, base+4, CR_BRICK,       baseX - 2.8,    baseY + 24.1,   1.0, 0.5);
    HudMessage(s:"damage taken";        HUDMSG_FADEOUT, base+5, CR_DARKRED,     baseX + 2.1,    baseY + 24.1,   1.0, 0.5);
    HudMessage(s:gambler;               HUDMSG_FADEOUT, base+6, CR_WHITE,       baseX - 2.8,    baseY + 36.1,   1.0, 0.5);
    HudMessage(s:"gambler die";         HUDMSG_FADEOUT, base+7, CR_LIGHTBLUE,   baseX + 2.1,    baseY + 36.1,   1.0, 0.5);
    HudMessage(s:norandom;              HUDMSG_FADEOUT, base+8, CR_TAN,         baseX - 2.8,    baseY + 48.1,   1.0, 0.5);
    HudMessage(s:"random damage";       HUDMSG_FADEOUT, base+9, CR_DARKBROWN,   baseX + 2.1,    baseY + 48.1,   1.0, 0.5);
}

function void DrawOneshotBlankHud(void)
{
    DrawOneshotHud_Base("\cf?????", "\cn???", "\cn???", "???", "???");
}

function void DrawOneshotHud(int weakness, int mweakness, int gambler, int sides, int norandom)
{
    int weakNum = weaknessNum(weakness);
    int mwekNum = mWeaknessNum(mweakness);

    int printName = skillName(weakness, mweakness);
    int printMWek = StrParam(d:mwekNum);
    int printWeak = StrParam(d:weakNum);
    int printGamb = cond(gambler, StrParam(s:"\cu1d\cf", d:sides), "No");
    int printRand = cond(norandom, "No", "With");

    DrawOneshotHud_Base(printName, printMwek, printWeak, printGamb, printRand);
}

function void updateClients(int weakness, int mweakness, int gambler, int gamblerdie, int norandom)
{
    ACS_ExecuteAlways(ONESHOT_SETCLIENT1, 0, weakness, mweakness, norandom);
    ACS_ExecuteAlways(ONESHOT_SETCLIENT2, 0, gambler, gamblerdie, 0);
}
